#include "descriptor/descriptor.h"

int main(void) {
	
	//colori
	ITEM	colore_muro, colore_pavimento, colore_giallo, colore_guida, nero_satinato, colore_occhio, colore_vetro, colore_eve, colore_contenitore;
	ITEM	colore_rubik, colore_rubik_bianco, colore_rubik_giallo, colore_rubik_rosso, colore_rubik_blu, colore_rubik_verde, colore_rubik_arancione;
	ITEM	colore_paralume, colore_lampada, colore_mobile;

	ITEM	scene, light;

	ITEM	stanza, pavimento, lampadina;
	//Wall-e
	ITEM	occhi_interno, occhio_sinistro, occhio_destro, occhio_sinistro_retro, occhio_destro_retro, collo;
	ITEM	corpo, corpo_2, sportello, guida;
	ITEM	braccio_sinistro, mano_sinistra, braccio_sinistro_righe, braccio_sinistro_snodo; 
	ITEM 	braccio_destro, mano_destra, braccio_destro_righe, braccio_destro_snodo;
	ITEM	cingolo_sinistro, cingolo_destro;
	//Eve
	ITEM	eve, eve_braccio_sinistro, eve_testa;

	//
	ITEM	mobile;
	ITEM	imac, schermo;
	ITEM	contenitore_1, contenitore_2, contenitore_3;
	ITEM	rubik, rubik_bianco, rubik_giallo, rubik_rosso, rubik_blu, rubik_verde, rubik_arancione;
	ITEM	birilli, birilli_strisce;
	ITEM	estintore_1, estintore_2;
	ITEM	lampada, lampada_paralume, lampada_vetro;

	char * texture_pavimento = "textures/pavimento.hr";
	char * texture_mobile = "textures/mobile.hr";
	char * texture_muro = "textures/muro.hr";
	char * texture_righe_sinistro = "textures/righe_sinistro.hr";
	char * texture_righe_destro = "textures/righe_destro.hr";
	char * texture_eve_testa = "textures/eve_testa.hr";

	float light_on = 30;
	float light_off = 0.00000000000000000000000000001;

//--------------------------------------------------------
	
	set_background(0.1, 0.1, 0.1, TRUE);
	set_ambient_light(1, 1, 1, 1);
	create_point_light(44, -20, 16, 1, 1, 1, 1.8, 0, "light");	
 	light = create_point_light(2.4, -2.55, 9.7, 1, 1, 1, light_off, 0, "light_lampadina");

//--------------------------------------------------------

/*** ATTRIBUTE colore_muro ***/
	colore_muro = create_attribute("colore_muro");
	set_color(colore_muro,0.12,0.12,0.12,0.590,0.661);
	set_reflectivity(colore_muro,0, 0);
	set_transparency(colore_muro,0,0,0,6.519);

/*** ATTRIBUTE colore_pavimento ***/
	colore_pavimento = create_attribute("colore_pavimento");
	set_color(colore_pavimento,1,1,0.95,0,0);
	set_reflectivity(colore_pavimento,0.25,1);
	set_transparency(colore_pavimento,0,0,0,1);

/*** ATTRIBUTE colore_giallo ***/
	colore_giallo = create_attribute("colore_giallo");
	set_color(colore_giallo,0.8941,0.8784,0,0.350,0.350);
	set_reflectivity(colore_giallo,0.040,0);
	set_transparency(colore_giallo,0,0,0,1.635);

/*** ATTRIBUTE colore_contenitore ***/
	colore_contenitore = create_attribute("colore_contenitore");
	set_color(colore_contenitore,0.47,0,0,0.7,0.7);
	set_reflectivity(colore_contenitore,0.040,0);
	set_transparency(colore_contenitore,0,0,0,1.635);

/*** ATTRIBUTE colore_guida ***/
	colore_guida = create_attribute("colore_guida");
	set_color(colore_guida,0.4941,0.4941,0.4941,0.2,0.413);
	set_reflectivity(colore_guida,0.050,0);
	set_transparency(colore_guida,0,0,0,3.554);

/*** ATTRIBUTE nero satinato***/
	nero_satinato = create_attribute("nero_satinato");
	set_color(nero_satinato,0.1765,0.1765,0.1765,0.410,1);
	set_reflectivity(nero_satinato,0,0);
	set_transparency(nero_satinato,0,0,0,0);

/*** ATTRIBUTE colore_occhio***/
	colore_occhio = create_attribute("colore_occhio");
	set_color(colore_occhio,1,1,1,0.6,0.6);

/*** ATTRIBUTE colore_eve***/
	colore_eve = create_attribute("colore_eve");
	set_color(colore_eve,1,1,1,0.380,0.256);
	set_reflectivity(colore_eve,0.050,10);
	set_transparency(colore_eve,0,0,0,0.100);

/*** ATTRIBUTE colore_vetro***/	
    	colore_vetro = create_attribute("vetro");
    	set_color(colore_vetro,0.8745,0.8588,1,0.5,0.5);
    	set_reflectivity(colore_vetro,0.0,0);
    	set_transparency(colore_vetro,0.87,0.68,1,1.2);

/*** ATTRIBUTE colore_rubik_bianco ***/
	colore_rubik_bianco = create_attribute("colore_rubik_bianco");
	set_color(colore_rubik_bianco,1,1,1,0.350,0.350);
	set_reflectivity(colore_rubik_bianco,0.040,0);
	set_transparency(colore_rubik_bianco,0,0,0,1.635);

/*** ATTRIBUTE colore_rubik_giallo ***/
	colore_rubik_giallo = create_attribute("colore_rubik_giallo");
	set_color(colore_rubik_giallo,0.8941,0.8784,0,0.350,0.350);
	set_reflectivity(colore_rubik_giallo,0.040,0);
	set_transparency(colore_rubik_giallo,0,0,0,1.635);

/*** ATTRIBUTE colore_rubik_rosso ***/
	colore_rubik_rosso = create_attribute("colore_rubik_rosso");
	set_color(colore_rubik_rosso,1,0,0,0.350,0.350);
	set_reflectivity(colore_rubik_rosso,0.040,0);
	set_transparency(colore_rubik_rosso,0,0,0,1.635);

/*** ATTRIBUTE colore_rubik_blu ***/
	colore_rubik_blu = create_attribute("colore_rubik_blu");
	set_color(colore_rubik_blu,0,0,1,0.350,0.350);
	set_reflectivity(colore_rubik_blu,0.040,0);
	set_transparency(colore_rubik_blu,0,0,0,1.635);

/*** ATTRIBUTE colore_rubik_verde ***/
	colore_rubik_verde = create_attribute("colore_rubik_verde");
	set_color(colore_rubik_verde,0,1,0,0.350,0.350);
	set_reflectivity(colore_rubik_verde,0.040,0);
	set_transparency(colore_rubik_verde,0,0,0,1.635);

/*** ATTRIBUTE colore_rubik_arancione ***/
	colore_rubik_arancione = create_attribute("colore_rubik_arancione");
	set_color(colore_rubik_arancione,1,0.5,0,0.350,0.350);
	set_reflectivity(colore_rubik_arancione,0.040,0);
	set_transparency(colore_rubik_arancione,0,0,0,1.635);

/*** ATTRIBUTE colore_rubik ***/
	colore_rubik = create_attribute("colore_rubik");
	set_color(colore_rubik,0,0,0,0.350,0.350);
	set_reflectivity(colore_rubik,0.040,0);
	set_transparency(colore_rubik,0,0,0,1.635);

/*** ATTRIBUTE colore_paralume ***/
	colore_paralume = create_attribute("colore_paralume");
	set_color(colore_paralume,0.9059,0.8745,0.6274,0.530,0.394);
	set_reflectivity(colore_paralume,0.040,0);
	set_transparency(colore_paralume,0,0,0,1.635);

/*** ATTRIBUTE colore_lampada ***/
	colore_lampada = create_attribute("colore_lampada");
	set_color(colore_lampada,0.5019,0.2509,0,0.530,0.394);
	set_reflectivity(colore_lampada,0.040,0);
	set_transparency(colore_lampada,0,0,0,1.635);

/*** ATTRIBUTE colore_mobile ***/
	colore_mobile = create_attribute("colore_mobile");
	set_color(colore_mobile,0.1765,0.1765,0.1765,0.410,1);
	set_reflectivity(colore_mobile,0,0);
	set_transparency(colore_mobile,0,0,0,0);

//--------------------------------------------------------

	stanza = read_obj("stanza_surface_list.obj", "stanza");
	set_domain_texture(stanza, colore_muro, texture_muro, 0, 0.143, 0, 0.107, 1, 0.2, 0.4);	
	set_translate(stanza, 3, -3, 2.2);

	pavimento = read_nurbs("pavimento_surface.db");
	set_domain_texture(pavimento, colore_pavimento, texture_pavimento, 0, 0.512, 0, 0.342, 1, 0.6, 0.8);
	set_translate(pavimento, 3, -3, 2.2);

//--------------------------------------------------------

	occhi_interno = read_obj("occhi_interno_surface_list.obj", "occhi_interno");
	set_attribute(occhi_interno,colore_occhio);
	set_translate(occhi_interno, 0, 0, 10);

	occhio_sinistro = read_obj("occhio_sinistro_surface_list.obj", "occhio_sinistro");
	set_attribute(occhio_sinistro,colore_guida);
	set_translate(occhio_sinistro, 0, 0, 10);

	occhio_destro = read_obj("occhio_destro_surface_list.obj", "occhio_destro");
	set_attribute(occhio_destro,colore_guida);
	set_translate(occhio_destro, 0, 0, 10);

	occhio_sinistro_retro = read_obj("occhio_sinistro_retro_surface_list.obj", "occhio_sinistro_retro");
	set_attribute(occhio_sinistro_retro,colore_guida);
	set_translate(occhio_sinistro_retro, 0, 0, 10);

	occhio_destro_retro = read_obj("occhio_destro_retro_surface_list.obj", "occhio_destro_retro");
	set_attribute(occhio_destro_retro,colore_guida);
	set_translate(occhio_destro_retro, 0, 0, 10);

	collo = read_obj("collo_surface_list.obj", "collo");
	set_attribute(collo,colore_guida);
	set_translate(collo, 0, 0, 10);

	sportello = read_nurbs("corpo_surface_15.db");
 	set_attribute(sportello,colore_giallo);
 	set_translate(sportello, 0, 0, 10);

	corpo = read_obj("corpo_surface_list.obj", "corpo");	
 	set_attribute(corpo,colore_giallo);
 	set_translate(corpo, 0, 0, 10);

	corpo_2 = read_obj("corpo_surface_list_2.obj", "corpo_2");
 	set_attribute(corpo_2,colore_guida);
 	set_translate(corpo_2, 0, 0, 10);

	guida = read_obj("guida_surface_list.obj", "guida");
 	set_attribute(guida,colore_guida);
 	set_translate(guida, 0, 0, 10);

	braccio_sinistro = read_obj("braccio_sinistro_surface_list.obj", "braccio_sinistro");
 	set_attribute(braccio_sinistro,colore_giallo);
 	set_translate(braccio_sinistro, 0, 0, 10);	

	braccio_sinistro_righe = read_nurbs("braccio_sinistro_surface_05.db");
	set_domain_texture(braccio_sinistro_righe, colore_giallo, texture_righe_sinistro, 0.2, 0.5, 0, 1.5, 0, 1, 1);
 	set_attribute(braccio_sinistro_righe,colore_giallo);
 	set_translate(braccio_sinistro_righe, 0, 0, 10);

	braccio_sinistro_snodo = read_nurbs("braccio_sinistro_surface_14_bis.db");
 	set_attribute(braccio_sinistro_snodo,colore_giallo);
 	set_translate(braccio_sinistro_snodo, 0, 0, 10);

	braccio_destro = read_obj("braccio_destro_surface_list.obj", "braccio_destro");
 	set_attribute(braccio_destro,colore_giallo);
 	set_translate(braccio_destro, 0, 0, 10);

	braccio_destro_righe = read_nurbs("braccio_destro_surface_05.db");
	set_domain_texture(braccio_destro_righe, colore_giallo, texture_righe_destro, 0.2, 0.5, 0, 1.5, 0, 1, 1);
 	set_attribute(braccio_destro_righe,colore_giallo);
 	set_translate(braccio_destro_righe, 0, 0, 10);

	braccio_destro_snodo = read_nurbs("braccio_destro_surface_14_bis.db");
 	set_attribute(braccio_destro_snodo,colore_giallo);
 	set_translate(braccio_destro_snodo, 0, 0, 10);

	mano_sinistra = read_obj("mano_sinistra_surface_list.obj", "mano_sinistra");
 	set_attribute(mano_sinistra,colore_guida);
 	set_translate(mano_sinistra, 0, 0, 10);

	mano_destra = read_obj("mano_destra_surface_list.obj", "mano_destra");
 	set_attribute(mano_destra,colore_guida);
 	set_translate(mano_destra, 0, 0, 10);

	cingolo_sinistro = read_obj("cingolo_sinistro_surface_list.obj", "cingolo_sinistro");
 	set_attribute(cingolo_sinistro, nero_satinato);
 	set_translate(cingolo_sinistro, 0, 0, 10);

	cingolo_destro = read_obj("cingolo_destro_surface_list.obj", "cingolo_destro");
 	set_attribute(cingolo_destro, nero_satinato);
 	set_translate(cingolo_destro, 0, 0, 10);

	lampadina = read_nurbs("lampadina.db");
 	set_attribute(lampadina,colore_vetro);
 	set_translate(lampadina, 0, 0, 10);

	eve = read_obj("eve_surface_list.obj", "eve");
 	set_attribute(eve,colore_eve);
 	set_translate(eve, 0, 0, 10);

	eve_testa = read_nurbs("eve_01.db");
	set_domain_texture(eve_testa, colore_eve, texture_eve_testa, 0.6, 0.0, 0.5, 0.1, 0, 0.38, 0.256);	
 	set_translate(eve_testa, 0, 0, 10);

	eve_braccio_sinistro = read_obj("eve_braccio_sinistro_surface_list.obj", "eve_braccio_sinistro");
 	set_attribute(eve_braccio_sinistro,colore_eve);
 	set_translate(eve_braccio_sinistro, 0, 0, 10);

	mobile = read_obj("mobile_surface_list.obj", "mobile");
	set_attribute(mobile,colore_mobile);	
	set_translate(mobile, 3, -3, 2.2);

	imac = read_obj("iMac_surface_list.obj", "imac");
 	set_attribute(imac,colore_eve);
	set_translate(imac, 3, -3, 2);

	schermo = read_nurbs("imac_surface_03.db");
 	set_attribute(schermo,colore_vetro);
	set_translate(schermo, 3, -3, 2);

	contenitore_1 = read_nurbs("contenitore_01.db");
	set_attribute(contenitore_1,colore_eve);
	set_translate(contenitore_1, 3, -3, 2.2);

	contenitore_2 = read_nurbs("contenitore_02.db");
	set_attribute(contenitore_1,colore_contenitore);
	set_translate(contenitore_2, 3, -3, 2.2);

	contenitore_3 = read_nurbs("contenitore_03.db");
	set_attribute(contenitore_3,colore_guida);
	set_translate(contenitore_3, 3, -3, 2.2);

	rubik = read_nurbs("rubik_surface_00.db");
 	set_attribute(rubik,colore_rubik);
	set_translate(rubik, -7.5, -1, 7.7);

	rubik_bianco = read_obj("rubik_bianco_surface_list.obj", "rubik_bianco");
 	set_attribute(rubik_bianco,colore_rubik_bianco);
	set_translate(rubik_bianco, -7.5, -1, 7.7);

	rubik_giallo = read_obj("rubik_giallo_surface_list.obj", "rubik_giallo");
 	set_attribute(rubik_giallo,colore_rubik_giallo);
	set_translate(rubik_giallo, -7.5, -1, 7.7);

	rubik_rosso = read_obj("rubik_rosso_surface_list.obj", "rubik_rosso");
 	set_attribute(rubik_rosso,colore_rubik_rosso);
	set_translate(rubik_rosso, -7.5, -1, 7.7);

	rubik_blu = read_obj("rubik_blu_surface_list.obj", "rubik_blu");
 	set_attribute(rubik_blu,colore_rubik_blu);
	set_translate(rubik_blu, -7.5, -1, 7.7);

	rubik_verde = read_obj("rubik_verde_surface_list.obj", "rubik_verde");
 	set_attribute(rubik_verde,colore_rubik_verde);
	set_translate(rubik_verde, -7.5, -1, 7.7);

	rubik_arancione = read_obj("rubik_arancione_surface_list.obj", "rubik_arancione");
 	set_attribute(rubik_arancione,colore_rubik_arancione);
	set_translate(rubik_arancione, -7.5, -1, 7.7);

	birilli = read_obj("birilli_surface_list.obj","birilli");
 	set_attribute(birilli,colore_eve);
	set_translate(birilli, 3, -3, 2.2);

	birilli_strisce = read_obj("birilli_strisce_surface_list.obj","birilli_strisce");
 	set_attribute(birilli_strisce,colore_contenitore);
	set_translate(birilli_strisce, 3, -3, 2.2);

	estintore_1 = read_obj("estintore_1_surface_list.obj", "estintore_1");
 	set_attribute(estintore_1,colore_contenitore);
	set_translate(estintore_1, 3, -3, 2.1);

	estintore_2 = read_obj("estintore_2_surface_list.obj", "estintore_2");
 	set_attribute(estintore_2,nero_satinato);
	set_translate(estintore_2, 3, -3, 2.1);

	lampada = read_obj("lampada_surface_list.obj", "lampada");
	set_attribute(lampada,colore_lampada);	
	set_translate(lampada, 3, -3, 2.2);

	lampada_vetro = read_nurbs("lampada_surface_03.db");
 	set_attribute(lampada_vetro,colore_vetro);
	set_translate(lampada_vetro, 3, -3, 2.2);

	lampada_paralume = read_nurbs("lampada_surface_01.db");
 	set_attribute(lampada_paralume,colore_paralume);
	set_translate(lampada_paralume, 3, -3, 2.2);

//--------------------------------------------------------

	scene = create_list(stanza, "scene");
	scene = insert_in_list(scene,pavimento);
	scene = insert_in_list(scene,occhi_interno);
	scene = insert_in_list(scene,occhio_sinistro);
	scene = insert_in_list(scene,occhio_destro);
	scene = insert_in_list(scene,occhio_sinistro_retro);
	scene = insert_in_list(scene,occhio_destro_retro);
	scene = insert_in_list(scene,collo);
	scene = insert_in_list(scene,sportello);
	scene = insert_in_list(scene,corpo);
	scene = insert_in_list(scene,corpo_2);
	scene = insert_in_list(scene,guida);
	scene = insert_in_list(scene,braccio_sinistro);
	scene = insert_in_list(scene,braccio_sinistro_righe);
	scene = insert_in_list(scene,braccio_sinistro_snodo);
	scene = insert_in_list(scene,braccio_destro);
	scene = insert_in_list(scene,braccio_destro_righe);
	scene = insert_in_list(scene,braccio_destro_snodo);
	scene = insert_in_list(scene,mano_sinistra);
	scene = insert_in_list(scene,mano_destra);
	scene = insert_in_list(scene,cingolo_sinistro);
	scene = insert_in_list(scene,cingolo_destro);
	scene = insert_in_list(scene,lampadina);
	scene = insert_in_list(scene,eve);
	scene = insert_in_list(scene,eve_braccio_sinistro);
	scene = insert_in_list(scene,eve_testa);
	scene = insert_in_list(scene,mobile);	
	scene = insert_in_list(scene,imac);
	scene = insert_in_list(scene,schermo);
	scene = insert_in_list(scene,contenitore_1);
	scene = insert_in_list(scene,contenitore_2);
	scene = insert_in_list(scene,contenitore_3);
	scene = insert_in_list(scene,rubik);
	scene = insert_in_list(scene,rubik_bianco);
	scene = insert_in_list(scene,rubik_giallo);
	scene = insert_in_list(scene,rubik_rosso);
	scene = insert_in_list(scene,rubik_blu);
	scene = insert_in_list(scene,rubik_verde);
	scene = insert_in_list(scene,rubik_arancione);
	scene = insert_in_list(scene,birilli);
	scene = insert_in_list(scene,birilli_strisce);
	scene = insert_in_list(scene,estintore_1);
	scene = insert_in_list(scene,estintore_2);
	scene = insert_in_list(scene,lampada);
	scene = insert_in_list(scene,lampada_vetro);
	scene = insert_in_list(scene,lampada_paralume);

	save_scene("WALL-E.md","WALL-E",scene);
	
	return(0);
}
